'********************************************************************
' Small PB/DDT sample on how to use the RRButton Custom Control
'********************************************************************
#COMPILE EXE
#REGISTER NONE
'#INCLUDE "WINCLEAN.INC"
#INCLUDE "WIN32API.INC"
#INCLUDE "RRBUTTON.INC"  'custom control button's include file
#RESOURCE "RRBUTTON.PBR" 'resource file with hand cursor, icons and version info

GLOBAL hFontUrl AS DWORD

DECLARE CALLBACK FUNCTION DlgMainProc

'********************************************************************
' Main entrance - create dialog and controls
'********************************************************************
FUNCTION WINMAIN (BYVAL hInst AS DWORD, BYVAL hPrevInstance AS DWORD, _
                  BYVAL lpszCmdLine AS ASCIIZ PTR, BYVAL nCmdShow AS LONG) AS LONG

  LOCAL hDlg AS DWORD, hRRparent AS DWORD, hIcon AS DWORD, _
        img AS STRING, rc AS RECT, lf AS LOGFONT

  DIALOG NEW 0, "RRButton demo", ,, 150, 183, %WS_CAPTION OR %WS_SYSMENU TO hDlg

  'Set program icon from resource file
  hIcon = LoadIcon(hInst, "SMILEYCL")
  DIALOG SEND hDlg, %WM_SETICON, %ICON_BIG, hIcon
  DIALOG SEND hDlg, %WM_SETICON, %ICON_SMALL, hIcon

 '-----------------------------------------------------------------------------
  'First, how to use the RRButton as label. Here as parent label and a child in it,
  'with different font. Nice effect for logotypes, etc.
  'First create the parent control. We need a handle
  'for the parent and dialog size in pixels to size parent properly.
 '-----------------------------------------------------------------------------
  hRRparent = CreateRRButton(hDlg, 299, "RRBUTTON CONTROL",  3, 3, 142, 29, _
                            %WS_CHILD OR %WS_CLIPCHILDREN OR %WS_VISIBLE, 0, 1)
  CONTROL SEND hDlg, 299, %WM_SETFONT, GetStockObject(%SYSTEM_FONT), 0
  CONTROL SEND hDlg, 299, %RBM_SETLABELMODE, 3, 0
  CONTROL SEND hDlg, 299, %RBM_SETTEXTPOS, %DT_SINGLELINE OR %DT_CENTER OR %DT_TOP, 0
  CONTROL SEND hDlg, 299, %RBM_SETTXTMARGINL, 32, 0
  CONTROL SEND hDlg, 299, %RBM_SETTXTMARGINT, 4, 0
  CONTROL SEND hDlg, 299, %RBM_SETTXTCOLORDN, RGB(255, 0, 0), 0
  CONTROL SEND hDlg, 299, %BM_SETIMAGE, %IMAGE_ICON, LoadIcon(0, BYVAL %IDI_WINLOGO)
  CONTROL SEND hDlg, 299, %RBM_SETIMAGEPOS, 4, 0
  CONTROL SEND hDlg, 299, %RBM_SETIMAGESIZE, 32, 32
  CONTROL SEND hDlg, 299, %RBM_SETTXT3D, 1, 0

  'Now create child for additional black text in Ansi var font (usually MS Sans Serif)
  'Must use SDK-style creation (CreateRRButton's last param is 0), since DDT can't do this.
  'Note, API-creation, so its font will be system font, usually bold and beautiful..
  GetClientRect hRRparent, rc
  CreateRRButton hRRparent, 300, "Added PB flexibility at no cost..",  40, 22, rc.nRight - 45, 20, _
                 %WS_CHILD OR %WS_VISIBLE, 0, 0
  CONTROL SEND hRRparent, 300, %RBM_SETLABELMODE, 1, 0
  CONTROL SEND hRRparent, 300, %WM_SETFONT, GetStockObject(%ANSI_VAR_FONT), 0
  CONTROL SEND hRRparent, 300, %RBM_SETCORNER, 0, 0
  CONTROL SEND hRRparent, 300, %RBM_SETTXTCOLOR, RGB(0, 0, 128), 0
  CONTROL SEND hRRparent, 300, %RBM_SETTXT3D, 1, 0

 '-----------------------------------------------------------------------------
  'ROUND BUTTON
 '-----------------------------------------------------------------------------
  CreateRRButton hDlg, 301, "",  7, 38, 23, 21, %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP, 0, 1
  CONTROL SEND hDlg, 301, %RBM_SETCORNER, 32, 0  'approx. 1.5 * MIN(w, h) for round ones
  img = "SMILEYCL"
  CONTROL SEND hDlg, 301, %RBM_SETIMAGE, %IMAGE_ICON, STRPTR(img)
  img = "SMILEYUP"
  CONTROL SEND hDlg, 301, %RBM_SETIMAGEUP, %IMAGE_ICON, STRPTR(img)
  img = "SMILEYDN"
  CONTROL SEND hDlg, 301, %RBM_SETIMAGEDN, %IMAGE_ICON, STRPTR(img)
  img = "SMILEYDS"
  CONTROL SEND hDlg, 301, %RBM_SETIMAGEDIS, %IMAGE_ICON, STRPTR(img)
  CONTROL SEND hDlg, 301, %RBM_SETIMAGESIZE, 32, 32
  CONTROL SEND hDlg, 301, %RBM_SETIMAGEPOS, 1, 1
  CONTROL SEND hDlg, 301, %RBM_SETIMGPOSLOCK, 1, 0
  SetWindowPos GetDlgItem(hDlg, 301), _    'resize control to image
               0, 0, 0, 34, 34, %SWP_NOMOVE OR %SWP_NOZORDER

 '-----------------------------------------------------------------------------
 ' OVAL BUTTON
 '-----------------------------------------------------------------------------
  CreateRRButton hDlg, 302, "Oval",  40, 39, 50, 22, %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP, 0, 1
  CONTROL SEND hDlg, 302, %RBM_SETCORNER, 75, 0 'approx. 1.5 * MAX(w, h) for oval ones

 '-----------------------------------------------------------------------------
 ' ROUNDRECT BUTTON
 '-----------------------------------------------------------------------------
  CreateRRButton hDlg, 303, "RoundRect", 95, 44, 50, 14, %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP, 0, 1

 '-----------------------------------------------------------------------------
 ' RECTANGULAR BUTTONS
 '-----------------------------------------------------------------------------
  CreateRRButton hDlg, 304, "or",    4, 66, 45, 14, %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP, 0, 1
  CreateRRButton hDlg, 305, "even", 51, 66, 45, 14, %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP, 0, 1
  CreateRRButton hDlg, 306, "Rectangular",  98, 66, 47, 14, _
                 %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP, 0, 1

  CONTROL SEND hDlg, 304, %RBM_SETCORNER,  15, 0  'rounded corners
  CONTROL SEND hDlg, 305, %RBM_SETCORNER,  10, 0  'cut-off, straight corners
  CONTROL SEND hDlg, 306, %RBM_SETCORNER,  0, 0   'rectangular, sharp corners
  CONTROL SEND hDlg, 304, %BM_SETIMAGE, %IMAGE_ICON, LoadIcon(0, BYVAL %IDI_ASTERISK)
  CONTROL SEND hDlg, 304, %RBM_SETIMGMARGINL, 4, 0

 '-----------------------------------------------------------------------------
 ' FOR SETTINGS..
 '-----------------------------------------------------------------------------
  CONTROL ADD OPTION, hDlg, 101, "Flat buttons ",   6,  90, 60, 12
  CONTROL ADD OPTION, hDlg, 102, "Raised buttons ", 6, 102, 60, 12
  CONTROL ADD OPTION, hDlg, 103, "Sunken Labels ",  6, 114, 60, 12
  CONTROL ADD OPTION, hDlg, 104, "Raised Labels ",  6, 126, 60, 12
  CONTROL SET CHECK   hDlg, 101, 1

  CONTROL ADD CHECKBOX, hDlg, 105, "Show focus ",  85,  90, 60, 12
  CONTROL ADD CHECKBOX, hDlg, 106, "Hand cursor ", 85, 102, 60, 12
  CONTROL ADD CHECKBOX, hDlg, 107, "Disabled ",    85, 114, 60, 12
  CONTROL ADD CHECKBOX, hDlg, 108, "3-D text ",    85, 126, 60, 12
  CONTROL SET CHECK   hDlg, 105, 1

 '-----------------------------------------------------------------------------
 ' URL LABEL..
 ' Comment: RRBUTTON defaults with brighter button color to be more
 ' visible in flat mode. Use %RBM_SETBTNCOLOR to set another color,
 ' like here, same as dialog instead. Also, when using other text
 ' colors, remember to set all three states. Even if button is turned
 ' into label, it responds to mouse move, down and up, etc..
 '-----------------------------------------------------------------------------
  CreateRRButton hDlg, 307, "or why not as a URL control..",  4, 144, 140, 12, _
                 %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP, 0, 1

  CONTROL SEND hDlg, 307, %RBM_SETCURSOR, 0, LoadCursor(hInst, "HAND")

  CONTROL SEND hDlg, 307, %RBM_SETLABELMODE, 1, 0 'make sure it's drawn flat, even in up/down state
  CONTROL SEND hDlg, 307, %RBM_SETBTNCOLOR,   GetSysColor(%COLOR_3DFACE), 0 'dialog's color
  CONTROL SEND hDlg, 307, %RBM_SETTXTCOLOR,   RGB(0, 0, 255), 0             'flat state
  CONTROL SEND hDlg, 307, %RBM_SETTXTCOLORUP, RGB(0, 0, 255), 0             'internal up state
  CONTROL SEND hDlg, 307, %RBM_SETTXTCOLORDN, RGB(255, 0, 0), 0             'internal down state
  CONTROL SEND hDlg, 307, %RBM_SETSHOWFOCUS, 1, 0                           'allow URL label to show focusrect

  GetObject GetStockObject(%SYSTEM_FONT), SIZEOF(lf), lf
  lf.lfWeight    = %FW_BOLD
  lf.lfUnderline = 1
  hFontUrl = CreateFontIndirect(lf)
  CONTROL SEND hDlg, 307, %WM_SETFONT, hFontUrl, 0

 '-----------------------------------------------------------------------------
 ' EXIT BUTTON
 '-----------------------------------------------------------------------------
  CreateRRButton hDlg, %IDCANCEL, "E&xit",  94, 164, 50, 14, _
                 %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP, 0, 1
  CONTROL SEND hDlg, %IDCANCEL, %RBM_SETCORNER,  4, 0
  CONTROL SEND hDlg, %IDCANCEL, %BM_SETIMAGE, %IMAGE_ICON, LoadIcon(0, BYVAL %IDI_HAND)
  CONTROL SEND hDlg, %IDCANCEL, %RBM_SETIMAGEPOS, -4, 0
  CONTROL SEND hDlg, %IDCANCEL, %RBM_SETIMGMARGINL, 4, 0

  DIALOG SHOW MODAL hDlg, CALL DlgMainProc

END FUNCTION

'********************************************************************
' Dialog Callback procedure
'********************************************************************
CALLBACK FUNCTION DlgMainProc
  SELECT CASE CBMSG
     CASE %WM_INITDIALOG : LOCAL h AS DWORD
     CASE %WM_DESTROY    : DeleteObject hFontUrl

     CASE %WM_PALETTECHANGED
        'if in 256 color mode, switching between app's with different palettes
        'can cause weird results. By trapping %WM_PALETTECHANGED and redrawing
        'entire dialog, this problem is fixed. Maybe not best solution, but it
        'works. Here we also need to redraw a child control in "logotype".
        IF CBWPARAM <> CBHNDL THEN
           h = GetDlgItem(GetDlgItem(CBHNDL, 299), 300) 'child in logo..
           RedrawWindow h, BYVAL 0, BYVAL 0, %RDW_INVALIDATE OR %RDW_UPDATENOW
           RedrawWindow CBHNDL, BYVAL 0, BYVAL 0, %RDW_INVALIDATE OR %RDW_UPDATENOW
        END IF

     CASE %WM_COMMAND
        IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
           SELECT CASE CBCTL
              CASE 101 'FLAT BUTTONS
                 CONTROL GET CHECK CBHNDL, CBCTL TO h
                 IF h THEN
                    FOR h = 301 TO 306
                       CONTROL SEND CBHNDL, h, %RBM_SETLABELMODE, 0, 0 'reset eventual label mode
                       CONTROL SEND CBHNDL, h, %RBM_SETRAISED, 0, 1    'reset eventual raised flag
                    NEXT
                    CONTROL ENABLE CBHNDL, 105
                    SendMessage CBHNDL, %WM_COMMAND, MAKLNG(105, 0), 0 'see if control shall show focusrect
                 END IF

              CASE 102 'RAISED BUTTONS
                 CONTROL GET CHECK CBHNDL, CBCTL TO h
                 IF h THEN
                    FOR h = 301 TO 306
                       CONTROL SEND CBHNDL, h, %RBM_SETLABELMODE, 0, 0 'reset eventual label mode
                       CONTROL SEND CBHNDL, h, %RBM_SETRAISED, 1, 1    'set raised flag
                    NEXT
                    CONTROL ENABLE CBHNDL, 105
                    SendMessage CBHNDL, %WM_COMMAND, MAKLNG(105, 0), 0 'see if control shall show focusrect
                 END IF

              CASE 103 'SUNKEN LABEL MODE
                 CONTROL GET CHECK CBHNDL, CBCTL TO h
                 IF h THEN
                    FOR h = 301 TO 306
                       CONTROL SEND CBHNDL, h, %RBM_SETLABELMODE, 3, 1 'set label mode flag
                       CONTROL SEND CBHNDL, h, %RBM_SETSHOWFOCUS, 0, 0 'no focusrect
                    NEXT
                    CONTROL DISABLE CBHNDL, 105
                 END IF

              CASE 104 'RAISED LABEL MODE
                 CONTROL GET CHECK CBHNDL, CBCTL TO h
                 IF h THEN
                    FOR h = 301 TO 306
                       CONTROL SEND CBHNDL, h, %RBM_SETLABELMODE, 2, 1 'set label mode flag
                       CONTROL SEND CBHNDL, h, %RBM_SETSHOWFOCUS, 0, 0 'no focusrect
                    NEXT
                    CONTROL DISABLE CBHNDL, 105
                 END IF

              CASE 105 'SHOW/HIDE FOCUS INDICATION
                 CONTROL GET CHECK CBHNDL, CBCTL TO h
                 IF h THEN
                    FOR h = 301 TO 306
                       CONTROL SEND CBHNDL, h, %RBM_SETSHOWFOCUS, 1, 1
                    NEXT
                 ELSE
                    FOR h = 301 TO 306
                       CONTROL SEND CBHNDL, h, %RBM_SETSHOWFOCUS, 0, 1
                    NEXT
                 END IF

              CASE 106 'SET CURSOR HAND OR ARROW
                 CONTROL GET CHECK CBHNDL, CBCTL TO h
                 IF h THEN
                    FOR h = 301 TO 306
                       CONTROL SEND CBHNDL, h, %RBM_SETCURSOR, 0, _
                               LoadCursor(BYVAL GetModuleHandle(BYVAL %Null), "HAND")
                    NEXT
                 ELSE
                    FOR h = 301 TO 306
                       CONTROL SEND CBHNDL, h, %RBM_SETCURSOR, %IDC_ARROW, 0
                    NEXT
                 END IF

              CASE 107 'DISABLE/ENABLE CONTROL
                 CONTROL GET CHECK CBHNDL, CBCTL TO h
                 IF h THEN
                    FOR h = 301 TO 307 : CONTROL DISABLE CBHNDL, h : NEXT
                 ELSE
                    FOR h = 301 TO 307 : CONTROL ENABLE CBHNDL, h : NEXT
                 END IF

              CASE 108 '3-D TEXT ON/OFF
                 CONTROL GET CHECK CBHNDL, CBCTL TO h
                 IF h THEN
                    FOR h = 301 TO 307
                       CONTROL SEND CBHNDL, h, %RBM_SETTXT3D, 1, 1
                    NEXT
                 ELSE
                    FOR h = 301 TO 307
                       CONTROL SEND CBHNDL, h, %RBM_SETTXT3D, 0, 1
                    NEXT
                 END IF

              CASE 301 TO 306 : BEEP
              CASE 307
                 MSGBOX "Can use ShellExecEx to send user to www address here",, "RRButton demo"

                 'EXAMPLE CALL..
                 'IF ShellExecute(0, "", "http://www.powerbasic.com", "", "", %SW_SHOWNORMAL) <= 32 THEN
                 '   something failed - show message or whatever..
                 'END IF

              CASE %IDCANCEL : DIALOG END CBHNDL       'Close the program

           END SELECT
        END IF

  END SELECT
END FUNCTION
